Bug 1778325 - Review Request: dicomanonymizer - A multi-threaded anonymizer for DICOM files
Summary: Review Request: dicomanonymizer - A multi-threaded anonymizer for DICOM files
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro
TreeView+ depends on / blocked
 
Reported: 2019-11-29 23:30 UTC by Alessio
Modified: 2019-12-21 02:06 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-12-21 00:56:30 UTC
Type: ---
zebob.m: fedora-review+


Attachments (Terms of Use)

Comment 1 Robert-André Mauchin 🐧 2019-12-10 22:37:42 UTC
 - License is Unlicense and there are some MIT licensed code too:

Expat License
-------------
DICOMAnonymizer-ed06792ec29bbe128110ec4f8c7184b7d0efbc9a/json.hpp
DICOMAnonymizer-ed06792ec29bbe128110ec4f8c7184b7d0efbc9a/optionparser.h

License: Unlicense ard MIT

 - Pre-release Release field should start at 0.1. Version should be 0 as no version has bee published yet:

Version: 9
Release: 0.1.%{?snap}%{?dist}

 - Why -j 4?

%make_build -j 4

 - Use install -p to keep timesamps:

install -pm 0755 anonymize %{buildroot}%{_bindir}/dicomanonymize

 - Use a better name for the archive:

Source0: %{url}/archive/%{commit}/%{name}-%{shortcommit}.tar.gz


 - Split the description to stay below 80 characters per line:

%description
A multi-threaded anonymizer for DICOM files implementing most of DICOM PS 3.15
AnnexE. Entries such as uid entries are replaced with hash values. This ensures
that partial runs of a studies DICOM files can be merged afterwards. This
project is written in C++ using the gdcm library and multiple threads to
accelerate processing. Warning: The operation performed by this tool is a 'soft'
de-identification. Instead of a white list of allowed tags the tool keeps a list
of tags known to frequently contain personal identifying information (PII) and
replaces only those. On the command line you specify a patient identifier
(PatientID/PatientName). Only if you do not keep a mapping of the new and the
old identifier this is considered an anonymization. If such a list exists the
operation performed is a de-identification (permits a later re-identification).

 - Fix your changelog entry:

dicomanonymizer.x86_64: W: incoherent-version-in-changelog 0-1.a ['1-0.20191125gited06792.fc32', '1-0.20191125gited06792']

%changelog
* Mon Nov 25 2019 Alessio <alciregi@gmail.com> - 0-0.1.20191125gited06792
- Initial commit

 - Remnove superfluous tab at line 45:

dicomanonymizer.src:45: W: mixed-use-of-spaces-and-tabs (spaces: line 6, tab: line 45)

 - Setup is not quiet: use -q or %autosetup:

%autosetup -n %{real_name}-%{commit}




Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "Expat License". 7 files have unknown
     license. Detailed output of licensecheck in
     /home/bob/packaging/review/dicomanonymizer/review-
     dicomanonymizer/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: dicomanonymizer-1-0.20191125gited06792.fc32.x86_64.rpm
          dicomanonymizer-debuginfo-1-0.20191125gited06792.fc32.x86_64.rpm
          dicomanonymizer-debugsource-1-0.20191125gited06792.fc32.x86_64.rpm
          dicomanonymizer-1-0.20191125gited06792.fc32.src.rpm
dicomanonymizer.x86_64: W: spelling-error Summary(en_US) anonymizer -> anonymity
dicomanonymizer.x86_64: W: spelling-error %description -l en_US anonymizer -> anonymity
dicomanonymizer.x86_64: W: spelling-error %description -l en_US uid -> yid, id, aid
dicomanonymizer.x86_64: W: spelling-error %description -l en_US gdcm -> GDP
dicomanonymizer.x86_64: W: spelling-error %description -l en_US de -> DE, ed, d
dicomanonymizer.x86_64: W: spelling-error %description -l en_US anonymization -> randomization, canonization, minimization
dicomanonymizer.x86_64: E: description-line-too-long C A multi-threaded anonymizer for DICOM files implementing most of DICOM PS 3.15 AnnexE.
dicomanonymizer.x86_64: E: description-line-too-long C Entries such as uid entries are replaced with hash values. This ensures that partial
dicomanonymizer.x86_64: E: description-line-too-long C runs of a studies DICOM files can be merged afterwards. This project is written in C++
dicomanonymizer.x86_64: E: description-line-too-long C Warning: The operation performed by this tool is a 'soft' de-identification. Instead
dicomanonymizer.x86_64: E: description-line-too-long C of a white list of allowed tags the tool keeps a list of tags known to frequently contain
dicomanonymizer.x86_64: E: description-line-too-long C personal identifying information (PII) and replaces only those. On the command line you
dicomanonymizer.x86_64: E: description-line-too-long C specify a patient identifier (PatientID/PatientName). Only if you do not keep a mapping
dicomanonymizer.x86_64: E: description-line-too-long C of the new and the old identifier this is considered an anonymization. If such a list
dicomanonymizer.x86_64: E: description-line-too-long C exists the operation performed is a de-identification (permits a later re-identification).
dicomanonymizer.x86_64: W: incoherent-version-in-changelog 0-1.a ['1-0.20191125gited06792.fc32', '1-0.20191125gited06792']
dicomanonymizer.x86_64: W: no-manual-page-for-binary dicomanonymize
dicomanonymizer.src: W: spelling-error Summary(en_US) anonymizer -> anonymity
dicomanonymizer.src: W: spelling-error %description -l en_US anonymizer -> anonymity
dicomanonymizer.src: W: spelling-error %description -l en_US uid -> yid, id, aid
dicomanonymizer.src: W: spelling-error %description -l en_US gdcm -> GDP
dicomanonymizer.src: W: spelling-error %description -l en_US de -> DE, ed, d
dicomanonymizer.src: W: spelling-error %description -l en_US anonymization -> randomization, canonization, minimization
dicomanonymizer.src: E: description-line-too-long C A multi-threaded anonymizer for DICOM files implementing most of DICOM PS 3.15 AnnexE.
dicomanonymizer.src: E: description-line-too-long C Entries such as uid entries are replaced with hash values. This ensures that partial
dicomanonymizer.src: E: description-line-too-long C runs of a studies DICOM files can be merged afterwards. This project is written in C++
dicomanonymizer.src: E: description-line-too-long C Warning: The operation performed by this tool is a 'soft' de-identification. Instead
dicomanonymizer.src: E: description-line-too-long C of a white list of allowed tags the tool keeps a list of tags known to frequently contain
dicomanonymizer.src: E: description-line-too-long C personal identifying information (PII) and replaces only those. On the command line you
dicomanonymizer.src: E: description-line-too-long C specify a patient identifier (PatientID/PatientName). Only if you do not keep a mapping
dicomanonymizer.src: E: description-line-too-long C of the new and the old identifier this is considered an anonymization. If such a list
dicomanonymizer.src: E: description-line-too-long C exists the operation performed is a de-identification (permits a later re-identification).
dicomanonymizer.src:39: W: setup-not-quiet
dicomanonymizer.src:45: W: mixed-use-of-spaces-and-tabs (spaces: line 6, tab: line 45)
4 packages and 0 specfiles checked; 18 errors, 16 warnings.

Comment 2 Alessio 2019-12-11 08:58:21 UTC
Thank you!

(In reply to Robert-André Mauchin from comment #1)
> 
>  - Why -j 4?
> 

Mmm, isn't the build process more performant in that way?

Comment 3 Alessio 2019-12-11 09:04:21 UTC
(In reply to Robert-André Mauchin from comment #1)
> install -pm 0755 anonymize %{buildroot}%{_bindir}/dicomanonymize

And what do you think about that?
The package (and git repository) is called DICOMAnonymizer, the compilation process produce an executable called anonymize. It makes sense to name "dicomanonymize" the command contained in the RPM, or it could be better "dicomanonymizer"?

Comment 4 Robert-André Mauchin 🐧 2019-12-11 14:49:31 UTC
(In reply to Alessio from comment #2)
> Thank you!
> 
> (In reply to Robert-André Mauchin from comment #1)
> > 
> >  - Why -j 4?
> > 
> 
> Mmm, isn't the build process more performant in that way?

No the purpose of %make_build is to automatically determine the number of cpus via %{?_smp_mflags}. See how these macros are defined:

make_build: %{__make} %{_make_output_sync} %{?_smp_mflags} %{_make_verbose}

_smp_mflags:        %([ -z "$RPM_BUILD_NCPUS" ] \
       && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \
       if [ "$RPM_BUILD_NCPUS" -gt 16 ]; then echo "-j16"; \
       elif [ "$RPM_BUILD_NCPUS" -gt 3 ]; then echo "-j$RPM_BUILD_NCPUS"; \
       else echo "-j3"; fi)

(In reply to Alessio from comment #3)
> (In reply to Robert-André Mauchin from comment #1)
> > install -pm 0755 anonymize %{buildroot}%{_bindir}/dicomanonymize
> 
> And what do you think about that?
> The package (and git repository) is called DICOMAnonymizer, the compilation
> process produce an executable called anonymize. It makes sense to name
> "dicomanonymize" the command contained in the RPM, or it could be better
> "dicomanonymizer"?

It's ok. Use what you feel it's best for your users.

Comment 6 Robert-André Mauchin 🐧 2019-12-11 15:45:34 UTC
Package is already approved, you can request the repo.

Comment 7 Gwyn Ciesla 2019-12-11 16:17:06 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/dicomanonymizer

Comment 8 Fedora Update System 2019-12-12 09:14:09 UTC
FEDORA-2019-85b16de93e has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-85b16de93e

Comment 9 Fedora Update System 2019-12-12 15:02:09 UTC
FEDORA-2019-a10791b1e0 has been submitted as an update to Fedora 30. https://bodhi.fedoraproject.org/updates/FEDORA-2019-a10791b1e0

Comment 10 Fedora Update System 2019-12-13 01:48:46 UTC
dicomanonymizer-0-0.1.20191125gited06792.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-85b16de93e

Comment 11 Fedora Update System 2019-12-13 02:56:21 UTC
dicomanonymizer-0-0.1.20191125gited06792.fc30 has been pushed to the Fedora 30 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-a10791b1e0

Comment 12 Fedora Update System 2019-12-21 00:56:30 UTC
dicomanonymizer-0-0.1.20191125gited06792.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 13 Fedora Update System 2019-12-21 02:06:43 UTC
dicomanonymizer-0-0.1.20191125gited06792.fc30 has been pushed to the Fedora 30 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.